/**
 * Titanium Windows Native Module - module.test3
 *
 * Copyright (c) 2015 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License.
 * Please see the LICENSE included with this distribution for details.
 */


#ifndef _COMAPPCMODULETEST3_HPP_
#define _COMAPPCMODULETEST3_HPP_

#include "ComAppcModuleTest3_EXPORT.h"
#include "Titanium/detail/TiBase.hpp"
#include "Titanium/Module.hpp"

namespace Com
{
	namespace Appc
	{
		namespace Module
		{
			using namespace HAL;

			class COMAPPCMODULETEST3_EXPORT Test3 : public Titanium::Module, public JSExport<Test3>
			{
				public:
					Test3(const JSContext&) TITANIUM_NOEXCEPT;
					virtual void postInitialize(JSObject& js_object) override;
					virtual void postCallAsConstructor(const JSContext& js_context, const std::vector<JSValue>& arguments) override;

					virtual ~Test3()               = default;
					Test3(const Test3&)            = default;
					Test3& operator=(const Test3&) = default;
#ifdef TITANIUM_MOVE_CTOR_AND_ASSIGN_DEFAULT_ENABLE
					Test3(Test3&&)                 = default;
					Test3& operator=(Test3&&)      = default;
#endif

					static void JSExportInitialize();

					TITANIUM_FUNCTION_DEF(testUsageInfo);
					TITANIUM_FUNCTION_DEF(testLogonCore);
			};
		}
	}
}
#endif // _COMAPPCMODULETEST3_HPP_
